#!/bin/sh
#


update_swap_label()
{
   NEW_LABEL=$1
   CURRENT_LABEL=`blkid -s LABEL -s TYPE | grep 'TYPE="swap"' | cut -d\" -f2`
   CHECK_LABEL="SWAP-`blkid -s LABEL -s TYPE | grep 'TYPE="swap"' | cut -d: -f1 | cut -d/ -f3`"
   if [ x$CURRENT_LABEL = x$CHECK_LABEL ]; then
     dev=`blkid | grep 'TYPE="swap"' | awk -F: '{print $1}'`
     swapoff $dev 
     if [ $? = 0 ]; then
        mkswap -L $NEW_LABEL $dev > /dev/null 2>&1
        echo $?
        swapon $dev
        return 
     else
       echo "Not able to disable swap to update the Label."
     fi # swapoff
   fi
 echo 1
}

GRUBFILE=/boot/grub/grub.conf
BACKUP_GRUBFILE=${GRUBFILE}.ovsbak_`date +%m%y%d`
FSTABFILE=/etc/fstab
BACKUP_FSTABFILE=${FSTABFILE}.ovsbak_`date +%m%y%d`


IFS=
for file in $GRUBFILE $FSTABFILE
do
  case $file in
  $GRUBFILE) backup_file=$BACKUP_GRUBFILE
             TMP=`mktemp /tmp/grub.XXXXXXXX`
             type=grub
             ;;
  $FSTABFILE) backup_file=$BACKUP_FSTABFILE
             TMP=`mktemp /tmp/fstab.XXXXXXXX`
             type=fstab
             ;;
  esac
# Read the  file
  while read line
  do

    LABEL=""
    START=`echo $line | awk '{print index($0, "LABEL=")}'`
    END=${line:(($START-1))}
    TRIM=${END%% *}
    LABEL=${TRIM#LABEL=*}


    if [ ${#TRIM} -gt 5 ] ; then
        ID=`blkid -t $TRIM -s UUID -l 2> /dev/null`
        UUID=${ID##*=}
        UUID=${UUID:1}
        UUID=${UUID/\"/}

        END="$END "
        END=${END#* }
        # Recreate the line replaceing LABEL with UUID
      if [ x$UUID = x ]; then
        if [ $type = fstab ]; then
          unset IFS
          set $line
          if [ x$3 = 'xswap' ]; then
            CURR_SWAP_LABEL=$1
            NEW_SWAP_LABEL=`uuidgen | awk -F- '{print $NF}'`
            STAT=$(update_swap_label $NEW_SWAP_LABEL)
            IFS=
            if [ $STAT = 0 ]; then
             echo $line | sed -e "s|$CURR_SWAP_LABEL|LABEL=$NEW_SWAP_LABEL|" >> $TMP
             continue;
            fi
          fi
        fi
      else
        echo ${line:0:((START-1))}UUID=$UUID $END >> $TMP
        continue
      fi
    fi
    echo $line >> $TMP

  done < $file

if ! cmp -s $TMP $file
then cp -p $file ${backup_file}
     mv $TMP $file
     chmod --reference ${backup_file} $file
else rm -f $TMP
fi

done


echo Files $FSTABFILE and $GRUBFILE updated to use UUID instead of LABEL.
echo
echo Original files are saved as
echo ${BACKUP_FSTABFILE}
echo ${BACKUP_GRUBFILE}
echo

